Attribute VB_Name = "BPALU"
' BP ALU 2.0
' (C) BASIC Production 2006
' http://basicproduction.nm.ru
'
'        - 1024*768 
'
' ,         .
'   ,    ?  ?
'      ,  ,    ,
'     ,   .
'             .
'      ,   
'    .
'
'   .
'      "" ,     .
'   ""       ,
'           .
'
'     - ,
'        .
'         .
'
'        Intel    .
'  16-  &H12345678   78563412.

'      FSTR  FVAL     .

'  API- CopyMemory    MOV_64TO32  MOV_32TO64
Declare Sub GetMem4 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Long)
'  API- CopyMemory  64  (8 )
Private Declare Sub GetMem8 Lib "msvbvm60" (ByVal Addr As Long, ByVal RetAddr As Long)

'   64-     64-   .
Public Type BITFLD
 Bytes(7) As Byte
End Type

Dim Flag_Overflow As Byte, Flag_Zero As Byte

Dim BitMask(7) As Byte

Dim EmptyVal As BITFLD

Sub Initialize()
 '  8   1    
 '      .     .
 BitMask(0) = 1 '1-    
 Dim Counter As Byte
 For Counter = 1 To 7
    BitMask(Counter) = BitMask(Counter - 1) * 2 '   (2^)
 Next Counter
End Sub

'         .
'    .
Public Function BIN1$(ByVal nByte As Byte)
  BIN1$ = String$(8, 48)
  For EnumBits = 0 To 7
    If nByte And 2 ^ EnumBits Then
      Mid$(BIN1$, 8 - EnumBits) = "1"
    End If
  Next EnumBits
End Function

'     .   8   BIN1
'      64  .
Function BIN64(Src As BITFLD, Optional ByVal LeftTrim As Boolean = True) As String
 Dim Counter As Integer
 For Counter = 0 To 7
    BIN64 = BIN1(Src.Bytes(Counter)) & BIN64
 Next Counter
 
 If LeftTrim Then
    For Counter = 1 To Len(BIN64)
        '     
        If Mid$(BIN64, Counter, 1) = "1" Then Exit For Else Mid$(BIN64, Counter, 1) = " "
    Next Counter
 End If
 BIN64 = LTrim$(BIN64)
End Function

' .   ,      :)
'     ,    
'     (. )  ()    () 
'      ,     Flag_Overflow
Sub ADD64(Dst As BITFLD, Src As BITFLD)
 Dim Counter As Integer, CounterB As Integer, Condition As Byte, NewBit As Byte
 Flag_Overflow = 0
 For CounterB = 0 To 7
    For Counter = 0 To 7
        If (Dst.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then Condition = Condition + 1
        If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then Condition = Condition + 1
        If NewBit Then NewBit = 0: Condition = Condition + 1
        If Condition = 1 Then '  1  3  
           Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Or BitMask(Counter) '   
        ElseIf Condition = 2 Then '  2  3  
           NewBit = 1 '     
           If (Dst.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then '  
              Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Xor BitMask(Counter) ' 
           End If
        ElseIf Condition = 3 Then ' 3  3  
           NewBit = 1 '     
           Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Or BitMask(Counter) '   
        End If
        Condition = 0
    Next Counter
 Next CounterB
 If NewBit Then Flag_Overflow = 1
 CheckZero Dst
End Sub

' 
'         Flag_Overflow
'  .
' 1.        .
'           .
'      , :     ,    
'    ,           .
' 2.   .
'      ,    ,   
'     .    ,  
'       ,    
'        .
' 3.   1
Sub SUB64(Dst As BITFLD, Src As BITFLD)
 Dim Counter As Integer, CounterB As Integer, Condition As Byte, NewBit As Byte
 Flag_Overflow = 0
 For CounterB = 0 To 7 '8  = 64 
    For Counter = 0 To 7
        If NewBit = 1 Then '     ,   
           If (Dst.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then 'If BIT=1
              Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Xor BitMask(Counter) 'BIT=0
              NewBit = 0 'FLG=0
           Else '  (BIT=0)       
              Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Or BitMask(Counter)
           End If
        End If
        If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then '   
           If (Dst.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then '  
              Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Xor BitMask(Counter) ' 
           Else '  
              '        
              '     10,      2
              '2-1=1,        
              Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Or BitMask(Counter)
              NewBit = 1 'FLG=1,     
           End If
        End If
    Next Counter
 Next CounterB
 If NewBit = 1 Then Flag_Overflow = 1
 CheckZero Dst
End Sub

' (  )  .    2
Sub SHL64(Src As BITFLD)
 Dim CounterB As Integer, Counter As Integer, Bit1 As Integer, MaskL As Integer
 For CounterB = 0 To 7
    For Counter = 0 To 7
        If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then
          MaskL = 1 '  
        Else
          MaskL = 0 '  
        End If
        If Bit1 = 1 Then '   
          If MaskL = 0 Then '  0  1
            Src.Bytes(CounterB) = Src.Bytes(CounterB) Xor BitMask(Counter)
          End If
        Else '   
          If MaskL = 1 Then '  1  0
            Src.Bytes(CounterB) = Src.Bytes(CounterB) Xor BitMask(Counter)
          End If
        End If
        Bit1 = MaskL
    Next Counter
 Next CounterB
 CheckZero Src
End Sub

' (  )  .    2
Sub SHR64(Src As BITFLD)
 Dim CounterB As Integer, Counter As Integer, Bit1 As Integer, MaskL As Integer
 For CounterB = 7 To 0 Step -1
    For Counter = 7 To 0 Step -1
        If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then
          MaskL = 1 '  
        Else
          MaskL = 0 '  
        End If
        If Bit1 = 1 Then '   
          If MaskL = 0 Then '  0  1
            Src.Bytes(CounterB) = Src.Bytes(CounterB) Xor BitMask(Counter)
          End If
        Else '   
          If MaskL = 1 Then '  1  0
            Src.Bytes(CounterB) = Src.Bytes(CounterB) Xor BitMask(Counter)
          End If
        End If
        Bit1 = MaskL
    Next Counter
 Next CounterB
 CheckZero Src
End Sub

'   .     
Sub QSHL64(Src As BITFLD)
 Dim Counter As Integer, Multiplier As Integer, PrevVal As Byte
 For Counter = 0 To 7
    Multiplier = Src.Bytes(Counter)
    Multiplier = Multiplier + Multiplier + PrevVal
    If Multiplier > 255 Then
      Src.Bytes(Counter) = Multiplier And &HFF
      PrevVal = Multiplier \ &HFF
    Else
      Src.Bytes(Counter) = Multiplier
      PrevVal = 0
    End If
 Next Counter
 CheckZero Src
End Sub

'   .     
Sub QSHR64(Src As BITFLD)
 Dim Counter As Integer, Multiplier As Long, ShiftBit As Boolean
 For Counter = 7 To 0 Step -1
    Multiplier = Src.Bytes(Counter)
    If ShiftBit Then Multiplier = Multiplier + 256
    If (Multiplier And 1) = 1 Then ShiftBit = True Else ShiftBit = False
    Multiplier = Multiplier \ 2
    Src.Bytes(Counter) = Multiplier
 Next Counter
 CheckZero Src
End Sub

'     
Sub NOT64(Src As BITFLD)
 Dim CounterB As Integer, Counter As Integer
 For CounterB = 0 To 7
    For Counter = 0 To 7
          Src.Bytes(CounterB) = Src.Bytes(CounterB) Xor BitMask(Counter)
    Next Counter
 Next CounterB
 CheckZero Src
End Sub

' .     (Dst)
 '1.   .
 '2.      B - ,      A.
 '3.   A    ,   B --   .
 '4.         .
Sub MUL64(Dst As BITFLD, SrcCopy As BITFLD)
 Dim Result As BITFLD, Src As BITFLD
 LSet Src = SrcCopy
 
 Dim CounterB As Integer, Counter As Integer
 For CounterB = 0 To 7
    For Counter = 0 To 7
       If (Src.Bytes(0) And 1) = 1 Then '  
         ADD64 Result, Dst
       End If
       QSHL64 Dst
       QSHR64 Src
    Next Counter
 Next CounterB
 LSet Dst = Result '   
 CheckZero Dst
End Sub

'     
Function HiBit(Src As BITFLD) As Integer
 Dim CounterB As Integer, Counter As Integer, Bit1 As Integer
 Bit1 = 63
 For CounterB = 7 To 0 Step -1
    For Counter = 7 To 0 Step -1
        If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then
          HiBit = Bit1: Exit Function
        End If
        Bit1 = Bit1 - 1
    Next Counter
 Next CounterB
 HiBit = -1
End Function

' ( 1)  .    100 -  2 (: 0 - , 63 - ).
Function LoBit(Src As BITFLD) As Integer
 Dim CounterB As Integer, Counter As Integer, Bit1 As Integer
 Bit1 = 0
 For CounterB = 0 To 7
    For Counter = 0 To 7
        If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then
          LoBit = Bit1: Exit Function
        End If
        Bit1 = Bit1 + 1
    Next Counter
 Next CounterB
 LoBit = -1
End Function

'    
' : , , 
'  :   (Dst)   ;
'                    (SrcCopy)     
'                    (ResultCopy)    
'
' 1.           
'      
' 2.     .
'               
'             ,
'           .
' 3.           2
Sub DIV64(Dst As BITFLD, SrcCopy As BITFLD, ResultCopy As BITFLD)
 Dim Src As BITFLD, Result As BITFLD
 LSet Src = SrcCopy
 Dim DivB1 As Integer, DivB2 As Integer
 DivB1 = HiBit(Dst) '     
 DivB2 = HiBit(Src) '     
 DivB2 = DivB1 - DivB2 '      -  
 Dim CounterB As Integer, Counter As Integer
 For Counter = 1 To DivB2 '        
  QSHL64 Src '  
 Next Counter
 For Counter = 1 To DivB2 + 1
     SUB64 Dst, Src
     If Flag_Overflow Then
      '        
      QSHL64 Result
      ADD64 Dst, Src
     Else
      '  
      QSHL64 Result
      If (Result.Bytes(0) And 1) <> 1 Then Result.Bytes(0) = Result.Bytes(0) Xor 1
     End If
     '     
     QSHR64 Src
 Next Counter
 LSet ResultCopy = Result
 CheckZero ResultCopy
End Sub

'   
'      10  ASC  .
'      ,       0
Function STR64(SrcCopy As BITFLD) As String
 Const ASC0 = 48 'Asc("0")
 Dim Src As BITFLD, Dst As BITFLD, Div10 As BITFLD, DivRet As BITFLD
 LSet Src = SrcCopy

 Div10.Bytes(0) = 10 ' ,  10 (  )
NextDigit: '   10
 LSet Dst = Src '=
 ',      (Dst  Src)
 DIV64 Dst, Div10, Src '  Src,    Dst
 STR64 = Chr$(Dst.Bytes(0) + ASC0) & STR64
 Dim CounterB As Integer
 For CounterB = 0 To 7
     If Src.Bytes(CounterB) > 0 Then GoTo NextDigit '  
 Next CounterB
End Function

'    16- 
'     16,        ASC,
'        ,    .
Function HEX64(SrcCopy As BITFLD) As String
 Const ASC0 = 48 'Asc("0")
 Dim Src As BITFLD, Dst As BITFLD, Div16 As BITFLD, DivRet As BITFLD
 LSet Src = SrcCopy

 Div16.Bytes(0) = 16 ' ,  16 ( 16- )
NextDigit: '   16
 LSet Dst = Src '=
 ',      (Dst  Src)
 DIV64 Dst, Div16, Src '  Src,    Dst
 If Dst.Bytes(0) < 10 Then
   HEX64 = Chr$(Dst.Bytes(0) + ASC0) & HEX64
 Else
   HEX64 = Chr$(Dst.Bytes(0) + 55) & HEX64
 End If
 Dim CounterB As Integer
 For CounterB = 0 To 7
     If Src.Bytes(CounterB) > 0 Then GoTo NextDigit '  
 Next CounterB
End Function

'   .
'     ,     1,10,100,1000  ..
'    .          
'        ASC.
'     . ,  "3" -  "0"  3,
'     . ,     
'  1,    10,    100  ..    
'   ,     .
Function VAL64(Dst As BITFLD, Src As String)
 Const ASC0 = 48 'Asc("0")
 
 Dim bCode As BITFLD '       
 Dim Mul10 As BITFLD, MulVal As BITFLD, DigVal As BITFLD
 
 Mul10.Bytes(0) = 10 ' ,  10 (  )
 DigVal.Bytes(0) = 1 '   
 
 LSet Dst = EmptyVal
 
 Src = UCase$(Trim$(Src))
 If Len(Src) > 2 Then
    If Left$(Src, 2) = "&H" Then ' 16- 
      Mul10.Bytes(0) = 16 ' ,  16 ( 16- )
      Src = Right$(Src, Len(Src) - 2)
    ElseIf Left$(Src, 2) = "&B" Then '  
      Mul10.Bytes(0) = 2 ' ,  2 (  )
      Src = Right$(Src, Len(Src) - 2)
    End If
 End If
 
 Dim Counter As Integer, b() As Byte
 b() = StrConv(Src, vbFromUnicode) '     
 For Counter = Len(Src) - 1 To 0 Step -1
    If b(Counter) < 48 Then '      
       Exit Function
    Else
        Select Case Mul10.Bytes(0)
        Case 10
            If b(Counter) > 57 Then Exit Function 'ASC("9")
        Case 16
            If (b(Counter) > 64) And (b(Counter) < 71) Then 'A-F
                b(Counter) = b(Counter) - 7 'ASC("A")=ASC("9")+7
            Else
                If b(Counter) > 57 Then Exit Function
            End If
        Case 2
            If b(Counter) > 49 Then Exit Function 'ASC("1")
        End Select
    End If
    bCode.Bytes(0) = b(Counter) - 48 '    ASCII   
    LSet MulVal = DigVal '      
    MUL64 MulVal, bCode  '       
    ADD64 Dst, MulVal    '     
    MUL64 DigVal, Mul10  '     ( )
 Next Counter
End Function

'  INC,DEC,AND,OR,XOR  ,
' ..      .
' ===================================================

'  ( ).  .
Sub INC64(Dst As BITFLD)
 Dim CounterB As Integer, Ext As Integer
 Flag_Overflow = 0
 Ext = Dst.Bytes(0) + 1
 For CounterB = 1 To 7
    If Ext > 255 Then
      Dst.Bytes(CounterB - 1) = Ext And &HFF
      Ext = (Ext - 255) + Dst.Bytes(CounterB)
    Else
      Dst.Bytes(CounterB - 1) = Ext
      Exit For
    End If
 Next CounterB
 If Ext > 255 Then
    Flag_Overflow = 1
    Dst.Bytes(7) = 0
 End If
 CheckZero Dst
End Sub

'  ( ).  .
Sub DEC64(Dst As BITFLD)
 Dim CounterB As Integer, Ext As Integer, Bit1 As Byte
 Flag_Overflow = 0
 Ext = Dst.Bytes(0) - 1
 For CounterB = 1 To 7
    If Ext < 0 Then
      Dst.Bytes(CounterB - 1) = 255
      Ext = Dst.Bytes(CounterB) - 1
    Else
      Dst.Bytes(CounterB - 1) = Ext
      Exit For
    End If
 Next CounterB
 If Ext < 0 Then
    Flag_Overflow = 1
    Dst.Bytes(7) = 255
 End If
 CheckZero Dst
End Sub

Sub AND64(Dst As BITFLD, Src As BITFLD)
 Dim CounterB As Integer
 For CounterB = 0 To 7
    Dst.Bytes(CounterB) = Dst.Bytes(CounterB) And Src.Bytes(CounterB)
 Next CounterB
 CheckZero Dst
End Sub

Sub OR64(Dst As BITFLD, Src As BITFLD)
 Dim CounterB As Integer
 For CounterB = 0 To 7
    Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Or Src.Bytes(CounterB)
 Next CounterB
 CheckZero Dst
End Sub

Sub XOR64(Dst As BITFLD, Src As BITFLD)
 Dim CounterB As Integer
 For CounterB = 0 To 7
    Dst.Bytes(CounterB) = Dst.Bytes(CounterB) Xor Src.Bytes(CounterB)
 Next CounterB
 CheckZero Dst
End Sub

'   4       Long
Sub MOV_64TO32(Dst As Long, Src As BITFLD)
 GetMem4 VarPtr(Src), Dst
End Sub

'      Long   
Sub MOV_32TO64(Dst As BITFLD, Src As Long)
 GetMem4 VarPtr(Src), ByVal VarPtr(Dst)
End Sub

Function IsOverFlow() As Boolean
 If Flag_Overflow = 1 Then IsOverFlow = True
End Function

Sub CheckZero(Src As BITFLD)
 Dim Counter As Integer
 Flag_Zero = 0
 For Counter = 0 To 7
    If Src.Bytes(Counter) > 0 Then
       Exit Sub
    End If
 Next Counter
 Flag_Zero = 1
End Sub

'      Double   
Sub MOV_DBL2FLD(Dst As BITFLD, ByVal Src As Double)
 GetMem8 VarPtr(Src), VarPtr(Dst)
End Sub

'      Double   
Sub MOV_FLD2DBL(Dst As Double, Src As BITFLD)
 GetMem8 VarPtr(Src), VarPtr(Dst)
End Sub

'BitNum=, Function=
Function BitPos(BitNum As Byte) As Byte
 'Dim Ost As Byte
 BitPos = BitNum Mod 8
 BitNum = BitNum - BitPos
 BitNum = BitNum \ 8
End Function

Function BUBound(Src As BITFLD) As Byte
 Dim Counter As Integer, CounterB As Integer
 For CounterB = 0 To 7
    If Src.Bytes(CounterB) > 0 Then
        For Counter = 0 To 7
            If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then
                BUBound = CounterB * 8 + Counter
            End If
        Next Counter
    End If
 Next CounterB
End Function

Function BLBound(Src As BITFLD) As Byte
 Dim Counter As Integer, CounterB As Integer
 For CounterB = 7 To 0 Step -1
    If Src.Bytes(CounterB) > 0 Then
        For Counter = 7 To 0 Step -1
            If (Src.Bytes(CounterB) And BitMask(Counter)) = BitMask(Counter) Then
                BLBound = CounterB * 8 + Counter
            End If
        Next Counter
    End If
 Next CounterB
End Function

Function BIT_GET(Dst As BITFLD, ByVal BitNum As Byte) As Boolean
 Dim Ost As Byte
 '       
 Ost = BitNum Mod 8
 BitNum = BitNum - Ost
 BitNum = BitNum \ 8
 '   
 If (Dst.Bytes(BitNum) And BitMask(Ost)) = BitMask(Ost) Then BIT_GET = True
End Function

Sub BIT_SET(Dst As BITFLD, ByVal BitNum As Byte)
 Dim Ost As Byte
 Ost = BitNum Mod 8
 BitNum = BitNum - Ost
 BitNum = BitNum \ 8
 
 Dst.Bytes(BitNum) = Dst.Bytes(BitNum) Or BitMask(Ost) '   
End Sub

Sub BIT_RESET(Dst As BITFLD, ByVal BitNum As Byte)
  Dim Ost As Byte
 Ost = BitNum Mod 8
 BitNum = BitNum - Ost
 BitNum = BitNum \ 8

If (Dst.Bytes(BitNum) And BitMask(Ost)) = BitMask(Ost) Then '  
    Dst.Bytes(BitNum) = Dst.Bytes(BitNum) Xor BitMask(Ost) ' 
 End If
End Sub

'     
Function GetExponent(Src As BITFLD) As Integer
 '  |  |  -   , 
 '  - ,    ;
 '  - ( ),  11 ;
 '  - ( ),  52 .
 ' 64-     11 
 Const Byte1Msk = &H7F ' 01111111 '        7  
 Const Byte2Msk = &HF0 ' 11110000 ' ,   4  
 Dim UInt As Long
 UInt = ((Src.Bytes(7) And Byte1Msk) * &H100) + (Src.Bytes(6) And Byte2Msk)
 GetExponent = CInt(UInt) \ 16
End Function

'  ,     
' Intel   (IEEE 754) .
',         ,
'     ( 51-  ).
'   11  ,   62  52 
Sub AddExponent(Dst As BITFLD, ByVal Exponent As Integer)
    Exponent = Exponent + 1023 '     
    Dim BitPosExp As Byte, Counter As Integer
    For Counter = 0 To 10 '  - 11
     QSHR64 Dst '   63-  51- 
    Next Counter
    BitPosExp = 52 '       
    For Counter = 0 To 10
       If (Exponent And 1) = 1 Then '  - 
         BIT_SET Dst, BitPosExp '      
       End If
       BitPosExp = BitPosExp + 1 '    
       Exponent = Exponent \ 2 ' -   
    Next Counter
End Sub

' 1.     .
' 2.    
' 3.           .
'         DstIntegerPart,
'    DstFraction.        ,
'       .
Sub GetFraction(DstIntegerPart As BITFLD, DstFraction As BITFLD, Src As BITFLD)
 Const Byte2Msk = &HF ' 00001111 '   ,   55-48
 Dim Cntr As Integer
 LSet DstIntegerPart = EmptyVal
 LSet DstFraction = EmptyVal
 
 DstFraction.Bytes(6) = Src.Bytes(6) And Byte2Msk '   
 For Cntr = 5 To 0 Step -1
    DstFraction.Bytes(Cntr) = Src.Bytes(Cntr) '   
 Next Cntr
 BIT_SET DstFraction, 52 '   
 For Cntr = 0 To 10 '  11     
  QSHL64 DstFraction
 Next Cntr
 
 '11- . =1023, (-1)<1023<(+1)
 Cntr = GetExponent(Src) - 1023
 Const HiByte64 = 7 ' 64-     7- ( )
 If Cntr > 0 Then '  
    For Cntr = 0 To Cntr - 1
     If (DstFraction.Bytes(HiByte64) And BitMask(7)) = BitMask(7) Then ' 63- 
        DstIntegerPart.Bytes(0) = DstIntegerPart.Bytes(0) + 1 '   0
     End If
     QSHL64 DstFraction
     QSHL64 DstIntegerPart
    Next Cntr
 ElseIf Cntr < 0 Then
    For Cntr = 0 To Cntr + 1 Step -1
     QSHR64 DstFraction
    Next Cntr
 End If
 If (DstFraction.Bytes(HiByte64) And BitMask(7)) = BitMask(7) Then
   DstIntegerPart.Bytes(0) = DstIntegerPart.Bytes(0) + 1 '   0
 End If
 QSHL64 DstFraction
End Sub

'        
'           63- 
'        .
'         
'        .
Function Fraction2Str(SrcFraction As BITFLD) As String
 Dim DigLn As Byte, Counter As Byte
 Counter = BLBound(SrcFraction)
 If Counter > 0 Then DigLn = 63 - BLBound(SrcFraction) + 1
 Dim FDivisor As BITFLD, DstFraction As BITFLD
 
 BIT_SET FDivisor, DigLn '  .     +1
 LSet DstFraction = SrcFraction
 For Counter = 0 To 63 - DigLn
  QSHR64 DstFraction '      .
 Next Counter
 
 Dim DivResult As BITFLD, Mul10 As BITFLD
 Mul10.Bytes(0) = 10 ',        
Do1:
  CMP64 DstFraction, FDivisor ' (FDivisor)  (DstFraction)  Flag_Overflow = 1
Do2:
  If Flag_Overflow = 1 Then ' (FDivisor) > (DstFraction)
    MUL64 DstFraction, Mul10 ' (*10)  
    CMP64 DstFraction, FDivisor '    
    If Flag_Overflow = 0 Then '   
        GoTo Do1 ' 
    Else
        Fraction2Str = Fraction2Str & "0"
        GoTo Do2 '      10 (  )
    End If
  Else
    DIV64 DstFraction, FDivisor, DivResult '    
    Fraction2Str = Fraction2Str & Chr$(DivResult.Bytes(0) + 48) ' 
  End If
  CMP64 DstFraction, EmptyVal '    
If Flag_Zero = 0 Then GoTo Do1 '    ,   
End Function

'      ,    .
', 1.625 = 625/1000.       .
Sub Str2Fraction(DstFraction As BITFLD, Fraction As String)
 Dim DecimalDigit As BITFLD, MulVal As BITFLD, Counter As Long
 VAL64 DecimalDigit, "1"
 VAL64 MulVal, "10"
 If Len(Fraction) > 16 Then Fraction = Left$(Fraction, 16)
 For Counter = 1 To Len(Fraction) ' 
    MUL64 DecimalDigit, MulVal ' 1*(10^ )
 Next Counter
 Dim Divident As BITFLD
 VAL64 Divident, Fraction '
 
 Dim NewFraction As BITFLD, NewFractionLn As Byte
 Dim FromBit As Byte
 ' ,  Fraction2Str.
 '      ,  .
 MulVal.Bytes(0) = 2 ',        

Do1:
  CMP64 Divident, DecimalDigit '     Flag_Overflow = 1
Do2:
  If Flag_Overflow = 1 Then '  > 
    MUL64 Divident, MulVal ' (*2)  
    CMP64 Divident, DecimalDigit '    
    If Flag_Overflow = 0 Then '   
        GoTo Do1 ' 
    Else
        If NewFractionLn > 51 Then GoTo FinishDiv '      
        NewFractionLn = NewFractionLn + 1
        QSHL64 NewFraction '        *2
        GoTo Do2 '      2 (  )
    End If
  Else
    Dim DivResult As BITFLD
    DIV64 Divident, DecimalDigit, DivResult '    
    If NewFractionLn > 51 Then GoTo FinishDiv ' 
    NewFractionLn = NewFractionLn + 1
    '   .   (*2)    .
    QSHL64 NewFraction '        *2
    '     ,
    '         .
    ADD64 NewFraction, DivResult
  End If
  CMP64 Divident, EmptyVal '    
If Flag_Zero = 0 Then GoTo Do1 '    ,   
FinishDiv:
 For Counter = 0 To 63 - NewFractionLn
    QSHL64 NewFraction '           
 Next Counter
 LSet DstFraction = NewFraction
End Sub

' .     ,  
'    :     , 
'.    .
Sub CMP64(DstCopy As BITFLD, SrcCopy As BITFLD)
 Dim Dst As BITFLD, Src As BITFLD
 LSet Dst = DstCopy
 LSet Src = SrcCopy
 SUB64 Dst, Src
End Sub

'     
Function FSTR64(Src As BITFLD) As String
 Dim IntPart As BITFLD, Fraction As BITFLD, MinusZero As BITFLD
 CMP64 Src, EmptyVal
 If Flag_Zero = 1 Then
    FSTR64 = "0" ' 
 Else
    BIT_SET MinusZero, 63
    CMP64 Src, MinusZero
    If Flag_Zero = 1 Then
       FSTR64 = "-0" ' 
    Else
        GetFraction IntPart, Fraction, Src '    
        FSTR64 = STR64(IntPart) & "." & Fraction2Str(Fraction) '  
    End If
 End If
 If (Src.Bytes(7) And BitMask(7)) = BitMask(7) Then ' 79- 
    FSTR64 = "-" & FSTR64 ' 
 End If
End Function

'     .
Sub FVAL64(Dst As BITFLD, Src As String)
 Dim IntPart As String, Fraction As String, SignSet As Boolean
 Dim FPPos As Integer, FPPos2 As Integer
 Src = Trim$(Src)
 If Left$(Src, 1) = "-" Then ' 
    SignSet = True
    Src = Right$(Src, Len(Src) - 1)
 End If
 FPPos = InStr(1, Src, ".") ' 
 FPPos2 = InStr(1, Src, ",") ' 
 If (FPPos > 0) And (FPPos2 > 0) Then '       
    Exit Sub '  
 ElseIf FPPos > 0 Then '
    IntPart = Left$(Src, FPPos - 1) '   
    Fraction = Right$(Src, Len(Src) - FPPos) '   
 ElseIf FPPos2 > 0 Then '
    IntPart = Left$(Src, FPPos2 - 1) '   
    Fraction = Right$(Src, Len(Src) - FPPos2) '   
 End If
 
 Dim IntPart64 As BITFLD
 Dim IntLen As Integer
 Dim Counter As Integer
 
 VAL64 IntPart64, IntPart '     
 Str2Fraction Dst, Fraction '     
 CMP64 IntPart64, EmptyVal '   . EmptyVal=0
 If Flag_Zero = 0 Then '  
    IntLen = HiBit(IntPart64) ' ,   
    BIT_RESET IntPart64, IntLen '   
    For Counter = 0 To IntLen
        '      ,
        '      .
        QSHR64 Dst
        If (IntPart64.Bytes(0) And 1) = 1 Then BIT_SET Dst, 63
        QSHR64 IntPart64
    Next Counter
 Else '  .
    IntLen = 64 - HiBit(Dst) '  . ( +1  =64)-(  )
    BIT_RESET Dst, HiBit(Dst) '   
    For Counter = 0 To IntLen - 2
        '     .
        '     .
        QSHL64 Dst
    Next Counter
    IntLen = -IntLen '       0...1
 End If
 AddExponent Dst, IntLen '    
 If SignSet Then BIT_SET Dst, 63 '     
End Sub
